"use strict";

require("core-js/modules/es.symbol.js");
require("core-js/modules/es.symbol.description.js");
require("core-js/modules/es.symbol.iterator.js");
require("core-js/modules/es.array.from.js");
require("core-js/modules/es.function.name.js");
require("core-js/modules/es.regexp.exec.js");
require("core-js/modules/es.regexp.test.js");
require("core-js/modules/es.regexp.to-string.js");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createManifest = void 0;
require("core-js/modules/es.array.concat.js");
require("core-js/modules/es.array.includes.js");
require("core-js/modules/es.array.iterator.js");
require("core-js/modules/es.array.join.js");
require("core-js/modules/es.array.map.js");
require("core-js/modules/es.array.slice.js");
require("core-js/modules/es.object.keys.js");
require("core-js/modules/es.object.to-string.js");
require("core-js/modules/es.object.values.js");
require("core-js/modules/es.set.js");
require("core-js/modules/es.string.includes.js");
require("core-js/modules/es.string.iterator.js");
require("core-js/modules/web.dom-collections.iterator.js");
function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }
function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }
function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
var fs = require("fs");
var path = require("path");
var createManifest = exports.createManifest = function createManifest() {
  // Path to your config.json
  var configPath = path.resolve("", "config.json");
  var reducersOutputPath = path.resolve("src/__doNotModify", "includedReducers.tsx");
  var flowsOutputPath = path.resolve("src/__doNotModify", "includedFlows.tsx");
  var componentsOutputPath = path.resolve("src/__doNotModify", "includedComponents.tsx");

  // Read your configuration
  var config = JSON.parse(fs.readFileSync(configPath, "utf8"));
  var flows = [config.strategyConfigs.default.flow];
  var operators = Object.values(config.strategyConfigs.operators);
  operators.map(function (operator) {
    // @ts-ignore
    flows.push(operator.flow);
  });
  var uniqueFlows = _toConsumableArray(new Set(flows));

  // Generate content for includedReducers.js
  var reducerContent = "\n// Auto-generated file. Do not delete or modify.\n".concat(uniqueFlows.map(function (flow) {
    return "import { ".concat(flow, "FlowReducer } from \"ouisys-engine/").concat(flow, "Flow\";");
  }).join("\n"), "\nconst includedReducers: any = {\n").concat(uniqueFlows.map(function (flow) {
    return "  ".concat(flow, "Flow: ").concat(flow, "FlowReducer,");
  }).join("\n"), "\n};\nexport default includedReducers;\n");
  var flowsContent = "\n// Auto-generated file. Do not delete or modify.\nimport React from \"react\";\n\nconst includedFlows: { [key: string]: any } = {\n".concat(uniqueFlows.map(function (flow) {
    var str = "".concat(flow, "Flow");
    var componentName = str.charAt(0).toUpperCase() + str.slice(1);
    return "  ".concat(componentName, ": require(\"../flows/").concat(componentName, "\").default,");
  }).join("\n"), "\n\n};\n\nexport default includedFlows;\n");
  var componentLines = [];
  if (config.strategy.includes("ask-mobile-number")) {
    componentLines.push("IdentifyFlowByMsisdn: require(\"../components/IdentifyFlowByMsisdn\").default,");
  }
  if (config.strategy.includes("ask-operator")) {
    componentLines.push("OperatorSelection: require(\"../components/OperatorSelection\").default,");
  }
  var componentsContent = "\n// Auto-generated file. Do not edit directly.\nimport React from \"react\";\n\nconst includedComponents: any = {\n  ".concat(componentLines.join("\n  "), "\n};\n\nexport default includedComponents;\n");
  fs.writeFileSync(reducersOutputPath, reducerContent);
  fs.writeFileSync(flowsOutputPath, flowsContent);
  fs.writeFileSync(componentsOutputPath, componentsContent);
  console.log("includedReducers.js has been generated.");
};
createManifest();