"use strict";

function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
require("core-js/modules/es.symbol.js");
require("core-js/modules/es.symbol.description.js");
require("core-js/modules/es.symbol.iterator.js");
require("core-js/modules/es.array.iterator.js");
require("core-js/modules/es.object.get-own-property-descriptor.js");
require("core-js/modules/es.object.to-string.js");
require("core-js/modules/es.regexp.exec.js");
require("core-js/modules/es.string.iterator.js");
require("core-js/modules/es.weak-map.js");
require("core-js/modules/web.dom-collections.iterator.js");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
require("core-js/modules/es.json.stringify.js");
var _path = _interopRequireDefault(require("path"));
var _fs = require("fs");
var _axios = _interopRequireDefault(require("axios"));
var envfile = _interopRequireWildcard(require("envfile"));
var _child_process = require("child_process");
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
var execute = function execute(command, callback) {
  (0, _child_process.exec)(command, function (error, stdout, stderr) {
    return callback(stdout);
  });
};
var disclaimerPath = "./src/localization/translations/legals.json";
var env = envfile.parseFileSync(_path.default.resolve("", ".env"));
var country = env.country,
  service = env.service,
  scenario = env.scenario;
var writeDisclaimers = function writeDisclaimers(data, isSuccess) {
  (0, _fs.writeFileSync)(disclaimerPath, JSON.stringify(data, null, 2), "utf8");
  if (isSuccess) {
    console.log("\uD83D\uDE07 Disclaimers generated here ".concat(_path.default.resolve("", "src/localization/translations/legals.json")));
  }
};
var getLegals = function getLegals() {
  return (0, _axios.default)({
    url: "https://c1.ouisys.com/api/v1/get-page-legals",
    //url:'http://localhost:3030/api/v1/get-page-legals',
    method: "get",
    params: {
      country: country,
      service: service,
      scenario: scenario
    }
  }).then(function (response) {
    if (response.data.length > 0) {
      writeDisclaimers(response.data, true);
    } else {
      writeDisclaimers([], false);
      console.log(" \uD83D\uDE14 ERROR: Could not get any disclaimers for the given data. Please check your .env file");
      console.table([{
        country: country,
        scenario: scenario,
        service: service
      }]);
    }
    return response.data;
  }).catch(function (err) {
    console.error(err);
  });
};
var _default = exports.default = getLegals;